//+------------------------------------------------------------------+
//|                                            VR---Limit losses.mq4 |
//|                  "Copyright 2014, www.trading-go.ru Project."    |
//|                                   "http://www.trading-go.ru"     |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, www.trading-go.ru Project."
#property link      "http://www.trading-go.ru"

#property version   "1.00"
#property strict
//    
input double DayLimit=100;
//     -1        ,  0  .
input int    Magic=-1;
//    
input int    Slippage=20;
bool trade_flag=false;   //   
string text="";          //  
//+------------------------------------------------------------------+
void OnTick()
  {
   double DayProfit=0;                                                                  //     
   int counter=0;                                                                       //  
   datetime op=0,time=TimeCurrent();                                                    //       

   RefreshRates();                                                                      //   (  )

   for(int i=OrdersHistoryTotal()-1; i>=0; i--)                                         //    
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))                                     //    
         if(OrderMagicNumber()==Magic || Magic==-1)                                     //    
           {
            op=OrderOpenTime();                                                         //    
            if(TimeDayOfYear(op)==TimeDayOfYear(time) && TimeYear(op)==TimeYear(time))  //            
               DayProfit+=OrderProfit()+OrderCommission()+OrderSwap();                  //  
           }

   for(int i=OrdersTotal()-1; i>=0; i--)                                                //      
      if(OrderSelect(i,SELECT_BY_POS))                                                  //    
         if(OrderMagicNumber()==Magic || Magic==-1)                                     //    
           {
            counter++;                                                                  //  
            DayProfit+=OrderProfit()+OrderCommission()+OrderSwap();                     //  
           }

   if((DayProfit+DayLimit)<=0){ trade_flag=true; text=" STOP";} else text=" allowed";   //            0    
                                                                                        //          
   if(trade_flag==true&&counter>0)close_all();                                          //           
   if(DayProfit==0){trade_flag=false; text=" allowed";}                                 //         0     
                                                                                        //     

   Comment(
           "\n","DayLimit ",DoubleToStr(DayLimit,2),               //     
           "\n","DayProfit ",DoubleToStr(DayProfit,2),             //       
           "\n","Dostupno",DoubleToStr(DayProfit+DayLimit,2),      //      
           "\n","Trade ",text                                      //         
           );

  }
//+------------------------------------------------------------------+
//    
void close_all()
  {

   double price=0;                                      //    
   for(int i=OrdersTotal()-1; i>=0; i--)                //     
      if(OrderSelect(i,SELECT_BY_POS))                  //   
         if(OrderMagicNumber()==Magic || Magic==-1)     //    
           {
            if(OrderType()==0)price=MarketInfo(OrderSymbol(),MODE_BID);                //        
            if(OrderType()==1)price=MarketInfo(OrderSymbol(),MODE_ASK);                //        
            if(!IsTradeContextBusy())                   //  
               if(OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(price,(int)MarketInfo(OrderSymbol(),MODE_DIGITS)),Slippage,clrGreen)==false) //     
                  Print(StringConcatenate(__FUNCTION__," OrderClose ",GetLastError()));                          //  
           }
  }
//+------------------------------------------------------------------+
